import * as tslint from "tslint";
import * as ts from "typescript";
import { SymbolTable } from "./table";
export declare class SymbolTableBuilder extends tslint.SyntaxWalker {
    private readonly program;
    private table;
    static build(sourceFile: ts.SourceFile, program: ts.Program): SymbolTable;
    private constructor(program);
    protected visitIdentifier(node: ts.Identifier): void;
    protected visitBinaryExpression(node: ts.BinaryExpression): void;
    private registerWriteUsageForAssignment(node);
    protected visitVariableDeclaration(node: ts.VariableDeclaration): void;
    protected visitPropertyDeclaration(node: ts.PropertyDeclaration): void;
    protected visitParameterDeclaration(node: ts.ParameterDeclaration): void;
    protected visitFunctionDeclaration(node: ts.FunctionDeclaration): void;
    protected visitClassDeclaration(node: ts.ClassDeclaration): void;
    protected visitEnumDeclaration(node: ts.EnumDeclaration): void;
    protected visitInterfaceDeclaration(node: ts.InterfaceDeclaration): void;
    protected visitNamedImports(node: ts.NamedImports): void;
    protected visitNamespaceImport(node: ts.NamespaceImport): void;
    protected visitImportEqualsDeclaration(node: ts.ImportEqualsDeclaration): void;
    protected visitExportAssignment(node: ts.ExportAssignment): void;
    protected visitPrefixUnaryExpression(node: ts.PrefixUnaryExpression): void;
    protected visitPostfixUnaryExpression(node: ts.PostfixUnaryExpression): void;
    protected visitModuleDeclaration(node: ts.ModuleDeclaration): void;
    private addVariable(node);
    private registerUsageIfMissing(node, flags);
}
