import * as ts from "typescript";
export declare class SymbolTable {
    private usages;
    private usagesBySymbol;
    registerUsageIfMissing(symbol: ts.Symbol, node: ts.Node, flags: UsageFlag): void;
    getUsage(node: ts.Node): Usage | undefined;
    allUsages(symbol: ts.Symbol): Usage[];
    getSymbols(): ts.Symbol[];
}
export declare class Usage {
    readonly symbol: ts.Symbol;
    readonly flags: UsageFlag;
    readonly node: ts.Node;
    dead: boolean;
    constructor(symbol: ts.Symbol, flags: UsageFlag, node: ts.Node);
    is(requestedFlags: UsageFlag): boolean;
    flagsAsString(): string;
    isUsedInside(node: ts.Node): boolean;
}
export declare enum UsageFlag {
    DECLARATION = 1,
    WRITE = 2,
    READ = 4,
}
